/*

  Rotary Encoder Module (KY-040)

  Parts required:
  - Arduino Board
  - Rotary Encoder Module (KY-040)

  Programming by : René Rasmussen
  Website : www.it-teknolog.dk
  Contact : renerasmussen@it-teknolog.dk
  Date : 21 Dec 2019
  Version : v1.0

  Modulet kan købes på www.arduinotech.dk

*/

#define encoderPinA 2                                       // set encoderPinA to digital port 2
#define encoderPinB 3                                       // set encoderPinB to digital port 3
#define encoderBtn 4                                        // set encoderBtn to digital port 4

int encoderPos = 0;                                         // set encoderPos = 0

void setup() {
  Serial.begin(9600);                                       // start Serial Monitor Communation
  pinMode(encoderPinA, INPUT_PULLUP);                       // set encoderPinA as INPUT and turn on PULLUP
  pinMode(encoderPinB, INPUT_PULLUP);                       // set encoderPinB as INPUT and turn on PULLUP
  pinMode(encoderBtn, INPUT_PULLUP);                        // set encoderBtn as INPUT and turn on PULLUP
  attachInterrupt(0, doEncoder, CHANGE);                    // start interrupt for deEncoder if it change value
}
int valRotary, lastValRotary;                               // set variables valRotary and lasValRotary

void loop() {
  int btn = digitalRead(encoderBtn);                        // read encoderBtn and store in btn variable
  
  Serial.print(btn);                                        // print btn value to Serial Monitor
  Serial.print(" ");                                        // print empty line
  Serial.print(valRotary);                                  // print valRotary value to Serial Monitor

  lastValRotary = valRotary;                                // set lastValRotary to valRotary
  Serial.println(" ");                                      // print empty line
}

void doEncoder()                                            // function   
{
  if (digitalRead(encoderPinA) == digitalRead(encoderPinB)) // read encoderPinA and encoderPinB and compare if encoderPinA is equal encoderPinB if Do
  {
    encoderPos--;                                           // decrease encoderPos
  }
  else
  {
    encoderPos++;                                           // increase encoderPos
  }
  valRotary = encoderPos / 2.5;                             // set valRotary to value encoderPos and divide with 2.5
}
